#!/usr/bin/ruby

class String
  def camel_case
    return self if self !~ /_/ && self =~ /[A-Z]+.*/
    split('_').map{|e| e.capitalize}.join
  end
end

gem_name = ARGV.first
gem_module = gem_name.camel_case

system 'clear'

# initial structure
system "bundle gem #{gem_name}"
Dir.chdir gem_name

# add bin/
system "mkdir bin"

# set up testing
puts
system "rspec --init"

# require our gem in spec_helper
system 'mv spec/spec_helper.rb spec/_spec_helper.rb'
old_spec_helper = File.open('spec/_spec_helper.rb', 'r')
File.open("spec/spec_helper.rb", 'w') do |spec_helper|
  spec_helper.puts "require '#{gem_name}'"
  old_spec_helper.lines.each do |line|
    spec_helper.puts line
  end
end
system 'rm spec/_spec_helper.rb'

# add smoke_spec.rb for basic
smoke_spec = File.new("spec/smoke_spec.rb", 'w')
smoke_spec.puts '# smoke test'
smoke_spec.puts "require 'spec_helper'"
smoke_spec.puts
smoke_spec.puts "describe #{gem_module} do"
smoke_spec.puts "  it 'has a version' do"
smoke_spec.puts "    expect(#{gem_module}::VERSION).to match(/^\\d+\\.\\d+\\.\\d+$/)"
smoke_spec.puts "  end"
smoke_spec.puts "end"
smoke_spec.close

# add dir for future specs
system "mkdir spec/#{gem_name}"

# update gemspec with dependencies
system "sed \"22a spec.add_development_dependency 'redcarpet'\" #{gem_name}.gemspec > result.txt"
system "mv result.txt #{gem_name}.gemspec"

system "sed \"23a spec.add_development_dependency 'rspec'\" #{gem_name}.gemspec > result.txt"
system "mv result.txt #{gem_name}.gemspec"

system "sed \"24a spec.add_development_dependency 'yard'\" #{gem_name}.gemspec > result.txt"
system "mv result.txt #{gem_name}.gemspec"

# order up!
puts
system "yard"

puts
system "rspec -f d"

puts
system "`command -v tree`" # only run if installed
